package com.daniminguet.videogameadvisor.dao;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Optional;

import javax.annotation.PostConstruct;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.daniminguet.videogameadvisor.config.AppConfig;
import com.daniminguet.videogameadvisor.model.Videogame;

@Repository
public class VideogameDaoImplMemory implements VideogameDao {
	
	public List<Videogame> videojuegos = new ArrayList<Videogame>();
	
	@Autowired
	private AppConfig appConfig;
	
	@PostConstruct
	public void iniciar() {
		videojuegos = UtilVideogameFileReader.readFile(appConfig.getFile(), appConfig.getSeparator(), appConfig.getListSeparator());
	}

	public Videogame buscarPorId(long id) {
		Optional<Videogame> videojuegosPorId = videojuegos.stream().filter(vg -> vg.getId() == id).findFirst();
		return videojuegosPorId.orElse(null);
	}
	
	public Collection<Videogame> mostrarTodos() {
		return videojuegos;
	}

	public void nuevoVideojuego(Videogame videojuego) {
		videojuegos.add(videojuego);
	}

	public void editarVideojuego(Videogame videojuego) {
		int i = obtenerId(videojuego.getId());
		if(i != -1) {
			videojuegos.set(i, videojuego);
		}
	}

	public void borrarVideojuego(long id) {
		int i = obtenerId(id);
		if(i != -1) {
			videojuegos.remove(i);
		}
	}
	
	private int obtenerId(long id) {
		boolean encontrado = false;
		int i = 0;
		
		while(!encontrado && i < videojuegos.size()) {
			if(videojuegos.get(i).getId() == id) {
				encontrado = true;
			} else {
				i++;
			}
		}
		
		return (encontrado) ? i : -1;
	}

}
